USE `grr`;
DROP TABLE IF EXISTS grr_j_mailuser_room;
CREATE TABLE grr_j_mailuser_room (login varchar(40) NOT NULL default '', id_room int(11) NOT NULL default '0', PRIMARY KEY  (login,id_room) );
DROP TABLE IF EXISTS grr_j_user_area;
CREATE TABLE grr_j_user_area (login varchar(40) NOT NULL default '', id_area int(11) NOT NULL default '0', PRIMARY KEY  (login,id_area) );
DROP TABLE IF EXISTS grr_j_user_room;
CREATE TABLE grr_j_user_room (login varchar(40) NOT NULL default '', id_room int(11) NOT NULL default '0', PRIMARY KEY  (login,id_room) );
DROP TABLE IF EXISTS grr_j_useradmin_area;
CREATE TABLE grr_j_useradmin_area (login varchar(40) NOT NULL default '', id_area int(11) NOT NULL default '0', PRIMARY KEY  (login,id_area) );
DROP TABLE IF EXISTS grr_log;
CREATE TABLE grr_log (LOGIN varchar(40) NOT NULL default '', START datetime NOT NULL default '0000-00-00 00:00:00', SESSION_ID varchar(64) NOT NULL default '', REMOTE_ADDR varchar(16) NOT NULL default '', USER_AGENT varchar(100) NOT NULL default '', REFERER varchar(64) NOT NULL default '', AUTOCLOSE enum('0','1') NOT NULL default '0', END datetime NOT NULL default '0000-00-00 00:00:00', PRIMARY KEY  (SESSION_ID,`START`));
DROP TABLE IF EXISTS grr_area;
CREATE TABLE grr_area (id int(11) NOT NULL auto_increment, area_name varchar(30) NOT NULL default '', access char(1) NOT NULL default '', order_display smallint(6) NOT NULL default '0', ip_adr varchar(15) NOT NULL default '',   morningstarts_area smallint(6) NOT NULL default '0', eveningends_area smallint(6) NOT NULL default '0', resolution_area smallint(6) NOT NULL default '0', eveningends_minutes_area smallint(6) NOT NULL default '0', weekstarts_area smallint(6) NOT NULL default '0', twentyfourhour_format_area smallint(6) NOT NULL default '0', calendar_default_values char(1) NOT NULL default 'y', enable_periods char(1) NOT NULL default 'n', display_days varchar(7) NOT NULL default 'yyyyyyy', PRIMARY KEY  (id));
DROP TABLE IF EXISTS grr_entry;
CREATE TABLE grr_entry (id int(11) NOT NULL auto_increment, start_time int(11) NOT NULL default '0', end_time int(11) NOT NULL default '0', entry_type int(11) NOT NULL default '0', repeat_id int(11) NOT NULL default '0', room_id int(11) NOT NULL default '1', timestamp timestamp(14) NOT NULL, create_by varchar(25) NOT NULL default '', name varchar(80) NOT NULL default '', type char(1) NOT NULL default 'A', description text, statut_entry char(1) NOT NULL default '-', option_reservation int(11) NOT NULL default '0',overload_desc text, PRIMARY KEY  (id), KEY idxStartTime (start_time), KEY idxEndTime (end_time));
DROP TABLE IF EXISTS grr_repeat;
CREATE TABLE grr_repeat ( id int(11) NOT NULL auto_increment, start_time int(11) NOT NULL default '0', end_time int(11) NOT NULL default '0', rep_type int(11) NOT NULL default '0', end_date int(11) NOT NULL default '0', rep_opt varchar(32) NOT NULL default '', room_id int(11) NOT NULL default '1', timestamp timestamp(14) NOT NULL, create_by varchar(25) NOT NULL default '', name varchar(80) NOT NULL default '', type char(1) NOT NULL default 'E', description text, rep_num_weeks tinyint(4) default '0',overload_desc text, PRIMARY KEY  (id));
DROP TABLE IF EXISTS grr_room;
CREATE TABLE grr_room ( id int(11) NOT NULL auto_increment,  area_id int(11) NOT NULL default '0',  room_name varchar(60) NOT NULL default '',  description varchar(60) NOT NULL default '',  capacity int(11) NOT NULL default '0',  max_booking smallint(6) NOT NULL default '-1', statut_room char(1) NOT NULL default '1', show_fic_room char(1) NOT NULL default 'n', picture_room varchar(50) NOT NULL default '', comment_room text NOT NULL, delais_max_resa_room smallint(6) NOT NULL default '-1', delais_min_resa_room smallint(6) NOT NULL default '0', allow_action_in_past char(1) NOT NULL default 'n', dont_allow_modify char(1) NOT NULL default 'n', order_display smallint(6) NOT NULL default '0', delais_option_reservation smallint(6) NOT NULL default '0', type_affichage_reser smallint(6) DEFAULT '0' NOT NULL, PRIMARY KEY  (id));
DROP TABLE IF EXISTS grr_utilisateurs;
CREATE TABLE grr_utilisateurs (login varchar(40) NOT NULL default '', nom varchar(30) NOT NULL default '', prenom varchar(30) NOT NULL default '', password varchar(32) NOT NULL default '', email varchar(100) NOT NULL default '', statut varchar(30) NOT NULL default '', etat varchar(20) NOT NULL default '', default_area smallint(6) NOT NULL default '0', default_room smallint(6) NOT NULL default '0', default_style varchar(50) NOT NULL default '', default_list_type varchar(50) NOT NULL default '', default_language char(3) NOT NULL default '', source varchar(10) NOT NULL default 'local', PRIMARY KEY  (login) );
DROP TABLE IF EXISTS grr_setting;
CREATE TABLE grr_setting (  NAME varchar(32) NOT NULL default '',  VALUE text NOT NULL,  PRIMARY KEY  (NAME));
DROP TABLE IF EXISTS grr_area_periodes;
CREATE TABLE grr_area_periodes (id_area int(11) NOT NULL default '0', num_periode smallint(6) NOT NULL default '0', nom_periode varchar(100) NOT NULL default '');
DROP TABLE IF EXISTS grr_type_area;
CREATE TABLE grr_type_area (id int(11) NOT NULL auto_increment, type_name varchar(30) NOT NULL default '',order_display smallint(6) NOT NULL default '0',couleur smallint(6) NOT NULL default '0',type_letter char(2) NOT NULL default '',  PRIMARY KEY  (id));
DROP TABLE IF EXISTS grr_j_type_area;
CREATE TABLE grr_j_type_area (id_type int(11) NOT NULL default '0', id_area int(11) NOT NULL default '0');
DROP TABLE IF EXISTS grr_calendar;
CREATE TABLE grr_calendar (DAY int(11) NOT NULL default '0');
DROP TABLE IF EXISTS grr_overload;
CREATE TABLE grr_overload (id int(11) NOT NULL auto_increment, id_area INT NOT NULL, fieldname VARCHAR(25) NOT NULL default '', fieldtype VARCHAR(25) NOT NULL default '', PRIMARY KEY  (id));
INSERT INTO grr_setting VALUES ('sessionMaxLength', '30');
INSERT INTO grr_setting VALUES ('automatic_mail', 'yes');

INSERT INTO grr_setting VALUES ('company', 'NOM_ETAB');
INSERT INTO grr_setting VALUES ('webmaster_name', 'Webmestre de GRR');
INSERT INTO grr_setting VALUES ('webmaster_email', 'admin@DNS_ETAB');
INSERT INTO grr_setting VALUES ('technical_support_email', 'support.technique@DNS_ETAB');
INSERT INTO grr_setting VALUES ('grr_url', 'http://DNS_ETAB/grr/');
INSERT INTO grr_setting VALUES ('disable_login', 'no');
INSERT INTO `grr_setting` (`NAME`, `VALUE`) VALUES 
('begin_bookings', '1199142000'),
('end_bookings', '1356908400');

INSERT INTO grr_setting VALUES ('title_home_page', 'Gestion et Rservation de Ressources');
INSERT INTO grr_setting VALUES ('message_home_page', 'En raison du caractre personnel du contenu, ce site est soumis  des restrictions utilisateurs. Pour accder aux outils de rservation, identifiez-vous :');
INSERT INTO grr_setting VALUES ('version', '1.9.3');
INSERT INTO grr_setting VALUES ('versionRC', '');
INSERT INTO grr_setting VALUES ('default_language', 'fr');
INSERT INTO grr_setting VALUES ('url_disconnect', '');
INSERT INTO grr_type_area VALUES (1, 'Cours', 1, 1, 'A');
INSERT INTO grr_type_area VALUES (2, 'Runion', 2, 2, 'B');
INSERT INTO grr_type_area VALUES (3, 'Stage', 3, 3, 'C');
INSERT INTO grr_type_area VALUES (4, 'Devoir', 4, 4, 'D');
INSERT INTO grr_type_area VALUES (5, 'Autre', 5, 5, 'E');
