#!/bin/bash  

SYS="/etc/sysconfig/envole"

. ParseDico
. /usr/share/eole/FonctionsEoleNg

# compatibilité

NOM_ETAB=`EscapeSQL "$libelle_etab"`
NOM_DOMAINE=$domaine_messagerie_etab
DNS_ETAB=$domaine_messagerie_etab

echo  "Installation de GRR "

## creation des bases et des users ##
PASS_ROOT=`/usr/bin/pwgen -1sn 8`;
echo "UPDATE user SET password=PASSWORD('$PASS_ROOT') WHERE user='root';
flush  privileges;" | mysql --defaults-file=/etc/mysql/debian.cnf mysql



if [ ! -d /var/lib/mysql/grr ]
then

PASS_GRR=`/usr/bin/pwgen -1sn 12`
echo "DROP DATABASE IF EXISTS grr;
CREATE DATABASE grr;
USE grr;GRANT ALL PRIVILEGES ON grr.* TO 'grr'@'localhost'
IDENTIFIED BY '$PASS_GRR' WITH GRANT OPTION;" | mysql -u root --password=$PASS_ROOT > /dev/null

if [ ! -d /var/www/html/grr ]
then
       mkdir /var/www/html/grr
fi

sed -e "s@DNS_ETAB@$DNS_ETAB@" $SYS/scribe_grr.sql > $SYS/scribe_grr.sql.1
sed -e "s@NOM_ETAB@$NOM_ETAB@" $SYS/scribe_grr.sql.1 > $SYS/scribe_grr.sql.2

mysql grr -u root -p$PASS_ROOT <  $SYS/scribe_grr.sql.2

rm $SYS/scribe_grr.sql.2
rm  $SYS/scribe_grr.sql.1
  
sed -e "s@PASS_GRR@$PASS_GRR@" $SYS/connect.inc.grr.php.ori > /var/www/html/grr/include/connect.inc.php

fi

if [ -e $SYS/init_envole_grr_portal.sql ]
then

cd /root/
## Sauvegarde des bases de donnees en fichiers .sql
SOURCE="envole"
PASS_ENVOLE=$(echo `grep dbPass /var/www/html/envole/serverdata.php` | cut -d"=" -f2|cut -d'"' -f2)
mysqldump -uenvole -p$PASS_ENVOLE portal > ${SOURCE}_`date +%D | sed 's;/;-;g'`.sql
## Compression des exports en tar.bz2 
tar jcf ${SOURCE}_maj_env_${NUM_MAJ}_`date +%D | sed 's;/;-;g'`.sql.tar.bz2 ${SOURCE}_`date +%D | sed 's;/;-;g'`.sql
## Suppression des exports non compresses
rm ${SOURCE}_`date +%D | sed 's;/;-;g'`.sql
mysql portal -u envole -p$PASS_ENVOLE < $SYS/init_envole_grr_portal.sql

fi




# pour le local_apps et grr.ini
cp $SYS/grr.ini /usr/share/sso/app_filters/
sed -e "s@NOM_DOMAINE@$NOM_DOMAINE@" $SYS/local_apps_grr.ini  > $SYS/local_apps_grr_ini.1

cat $SYS/local_apps_grr_ini.1 >> /usr/share/sso/app_filters/local_apps.ini
rm $SYS/local_apps_grr_ini.1
# pour le profil
cp $SYS/profil.py /usr/share/sso/user_infos/

chown -R www-data:www-data /var/www/html/*

#/etc/init.d/apache2 restart
/etc/init.d/eole-sso restart

